#!/usr/bin/ipython
from numpy import *
import matplotlib.pyplot as plt
import pylab as p
import mpl_toolkits.mplot3d.axes3d as p3
import mpl_toolkits.mplot3d as p2

import os

from colorsys import *

try:
    os.remove("clusters3d_out.pyc")
except:
    pass

import clusters3d_out

clusters = clusters3d_out.clusters

clusterCount = len(clusters)

colors = []
for i in xrange(clusterCount):
  h = i/(clusterCount*1.0)
  l = .5
  s = .9
  (r,g,b) = hls_to_rgb(h,l,s)
  colors.append( "#%02x%02x%02x" % (r*255,g*255,b*255))

fig = p.figure()
ax = p3.Axes3D(fig)
for i in range(clusterCount):
  cluster = clusters[i]
  xs = cluster[0::3]
  ys = cluster[1::3]
  zs = cluster[2::3]
  
  ax.scatter3D(xs, ys, zs, color=colors[i] , marker="o")
  ax.set_xlabel('X')
  ax.set_ylabel('Y')
  ax.set_zlabel('Z')
fig.show()
