#ifndef CLUSTERSIZEPLOT_H
#define CLUSTERSIZEPLOT_H
#include "qwt_plot.h"
#include "qwt_plot_curve.h"
#include "qwt_plot_marker.h"

#include "spc/xycollectionplot.h"

class ClusterSizePlot : public QwtPlot
{
    Q_OBJECT
public:
	ClusterSizePlot(QWidget *parent = 0);
	void setData(XyCollectionPlot data);

signals:
	void temperatureChanged(double temperature);

public slots:
	void handleClick(const QPointF &point);
	void setTemperature(double temperature);

private:
	unsigned int nCurves;
	std::vector<QwtPlotCurve*> curves;

	QwtPlotMarker selectedTemperatureMarker;
	QwtPlotMarker followingTemperatureMarker;

	double currentTemperature;

};

#endif // CLUSTERSIZEPLOT_H
