#include "plugininterface.h"
#ifndef CUSTOMWIDGETPLUGIN_H
#define CUSTOMWIDGETPLUGIN_H

#include <QDesignerCustomWidgetInterface>
#include <QtDesigner/QtDesigner>
#include <QtCore/qplugin.h>

class MyCustomWidgets: public QObject, public QDesignerCustomWidgetCollectionInterface
 {
     Q_OBJECT
     Q_INTERFACES(QDesignerCustomWidgetCollectionInterface)

 public:
     MyCustomWidgets(QObject *parent = 0);

     virtual QList<QDesignerCustomWidgetInterface*> customWidgets() const;

 private:
     QList<QDesignerCustomWidgetInterface*> widgets;
 };

class SusceptibilityPlugin : public PluginInterface
{
public:
    SusceptibilityPlugin(QObject* parent=0);
    QWidget *createWidget(QWidget *parent);
};

class FileChooserPlugin : public PluginInterface
{
public:
    FileChooserPlugin(QObject* parent=0);
    QWidget *createWidget(QWidget *parent);
};

class ReductionChooserPlugin : public PluginInterface
{
public:
	ReductionChooserPlugin(QObject* parent=0);
	QWidget *createWidget(QWidget *parent);
};

class DatasetInformationPlugin : public PluginInterface
{
public:
	DatasetInformationPlugin(QObject* parent=0);
	QWidget *createWidget(QWidget *parent);
};

class ClusterSizePlotPlugin : public PluginInterface
{
public:
	ClusterSizePlotPlugin(QObject* parent=0);
	QWidget *createWidget(QWidget *parent);
};


#endif
