#include "datasetinformation.h"
#include "ui_datasetinformation.h"

DatasetInformation::DatasetInformation(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::DatasetInformation)
{
    ui->setupUi(this);
	currentDataset = NULL;
}

DatasetInformation::~DatasetInformation()
{
    delete ui;
}

void DatasetInformation::updateInfo() {
	if(currentDataset == NULL) {
		ui->nDimensionsLabel->setText("No data yet");
		ui->nSamplesLabel->setText("No data yet");
		ui->viewButton->setEnabled(false);
	} else {
		ui->nDimensionsLabel->setText(QString::number(currentDataset->nDimensions));
		ui->nSamplesLabel->setText(QString::number(currentDataset->nSamples));
		ui->viewButton->setEnabled(true);
	}
}

void DatasetInformation::setDataset(InputDataset *newDataset) {
	currentDataset = newDataset;
	updateInfo();
}

void DatasetInformation::on_viewButton_clicked()
{
	emit(viewDataset(currentDataset));
}

void DatasetInformation::setTitle(QString s) {
	ui->datasetInfoBox->setTitle(s);
}
