#include <QtGui>
#include "filechooser.h"
#include "ui_filechooser.h"

FileChooser::FileChooser(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::FileChooser)
{
    ui->setupUi(this);
}

FileChooser::~FileChooser()
{
    delete ui;
}

void FileChooser::changeEvent(QEvent *e)
{
    QWidget::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void FileChooser::on_selectFileButton_clicked()
{
    QString filename = QFileDialog::getOpenFileName((QWidget*)this, "Select input file", "input/", "All files (*.*)");
    if(filename != NULL) {
        ui->fileNameField->setText(filename);
        emit(fileNameChanged(filename, ui->comboBox->currentIndex()));
    }
}

void FileChooser::on_pushButton_clicked()
{
    emit(openFile(ui->fileNameField->text(), ui->comboBox->currentIndex()));
}

void FileChooser::addFormats(QStringList formats) {
    ui->comboBox->addItems(formats);
}

void FileChooser::setFilename(QString filename) {
    ui->fileNameField->setText(filename);
}
