#ifndef PLUGININTERFACE_H
#define PLUGININTERFACE_H

#include <QDesignerCustomWidgetInterface>

class PluginInterface : public QObject, public QDesignerCustomWidgetInterface
{
    Q_OBJECT
    Q_INTERFACES(QDesignerCustomWidgetInterface)

public:
    PluginInterface(QObject *parent = 0);

    bool isContainer() const;
    bool isInitialized() const;
    QIcon icon() const;
    QString domXml() const;
    QString group() const;
    QString includeFile() const;
    QString name() const;
    QString toolTip() const;
    QString whatsThis() const;
	virtual QWidget *createWidget(QWidget *parent);
    void initialize(QDesignerFormEditorInterface *core);

protected:
    bool initialized;
    QIcon _icon;
    QString _domXml;
    QString _group;
    QString _includeFile;
    QString _name;
    QString _toolTip;
    QString _whatsThis;
};

#endif // PLUGININTERFACE_H
