#ifndef LRATIOQUALITY_H
#define LRATIOQUALITY_H

#include <vector>
#include <set>

class ClusterQuality
{
public:
	ClusterQuality(std::vector<std::vector<double> > &points, std::vector<std::vector<int> > &clusters);

	void calculateLratioQualityAndIsolationDistance();

	double calculateSilhouette(unsigned int cluster);
	double calculateAverageSilhouettes();

	void printFmeasurePrecisionAndRecall(std::vector<std::vector<int> > cutClusters);

	double fmeasure(std::vector<int> cluster, std::vector<int> cutCluster, int flag=0);

	std::vector<std::vector<double> > *points;
	std::vector<std::vector<int> > *clusters;

	std::vector< std::vector <double> > mahalForCluster;
	std::vector< std::vector <double> > mahalForNoise;

};

#endif // LRATIOQUALITY_H
