#ifndef DATALOADER_H
#define DATALOADER_H
#include <QtCore>
#include "inputdataset.h"


class DataLoader
{
public:
    static InputDataset* loadFile(QString filename, int filetypeIndex);
	static InputDataset* loadFile(char *filename, int filetypeIndex);
	//TODO: factory
    static InputDataset* loadAsciiFile(QString filename);
	static InputDataset* loadAxonaFile(QString filename);

	static void loadCutFile(const char *filename, const std::vector<std::vector<double> > &points, std::vector<std::vector<int> > &lastComputedClusterIds, std::vector<std::vector<int> > &cutfileIds);

    static QStringList filetypes();

    enum Filetype { ASCII, AXONA };
};

#endif // DATALOADER_H
