#include "inputdataset.h"
#include <stdio.h>

InputDataset::InputDataset(int nDimensions, int nSamples, int nChannels)
{
	//TODO: should we really do this here? I think preferably maybe nDimensions * nChannels should be used as the first input
	//parameter, and nChannels is removed.
	this->nDimensions = nDimensions;
    this->nSamples = nSamples;
	this->nChannels = nChannels;
	isReduced = false;
	resizeVectorsToParameters();

}

InputDataset::InputDataset(const InputDataset &dataset) {
    nDimensions = dataset.nDimensions;
    nSamples = dataset.nSamples;
	nChannels = dataset.nChannels;
	isReduced = dataset.isReduced;
	data.resize(nSamples);
	for(unsigned int i=0;i<nSamples;i++) {
		data[i] = std::vector<double>(dataset.data[i]);
	}
}

InputDataset::~InputDataset() {
}

void InputDataset::resizeVectorsToParameters() {
	data.resize( nSamples, std::vector<double>( this->nDimensions, 0) );
}


InputDataset *InputDataset::extractChannel(int channel) const {

	int dimsPerChannel = nDimensions / nChannels;

	InputDataset *outData = new InputDataset(dimsPerChannel, nSamples, 1);
	for(unsigned int spike=0;spike < nSamples; spike++) {
		for(int i=0;i<dimsPerChannel;i++) {
			outData->data[spike][i] = data[spike][ channel*dimsPerChannel + i];
		}

	}


	return outData;
}

void InputDataset::print() {
	printf("Dataset: %d channels, %d spikes, %d dimensions\n", nChannels, nSamples, nDimensions);
	for(unsigned int i=0;i<nSamples;i++) {
		for(unsigned int j=0;j<nDimensions;j++) {
			printf("%f ", data[i][j]);
		}
		printf("\n");
	}
	fflush(stdout);
}
