#ifndef INPUTDATASET_H
#define INPUTDATASET_H

#include <vector>
#include <map>
#include <string>

#include <reduction/reduction.h>

class Reduction;

class InputDataset
{
public:
	InputDataset(int nDimensions, int nSamples, int nChannels);
    InputDataset(const InputDataset &dataset);
    ~InputDataset();

	void resizeVectorsToParameters();

    unsigned int nDimensions;
    unsigned int nSamples;
	unsigned int nChannels;

    std::vector<std::vector<double> > data;

	std::map<std::string, std::string> metaData;
	std::map<std::string, std::string>::iterator metaDataIterator;

	bool isReduced;

	Reduction *reduceClass;

	InputDataset *extractChannel(int channel) const;

	void print();

};



#endif // INPUTDATASET_H
