#ifndef DATASETVIEWER_H
#define DATASETVIEWER_H

#include <QDialog>
#include "inputdataset.h"
#include "qwt_plot.h"
#include "qwt_plot_curve.h"

namespace Ui {
    class DatasetViewer;
}

class DatasetViewer : public QDialog
{
    Q_OBJECT

public:
	explicit DatasetViewer(InputDataset *dataset, QWidget *parent = 0);
    ~DatasetViewer();

private:
	InputDataset *dataset;
	InputDataset *reverseDataset;
    Ui::DatasetViewer *ui;
	QwtPlot *plot;
	QwtPlot *reversePlot;
	QwtPlotCurve *curve;
	QwtPlotCurve *reverseCurve;
	double *xrange;
	double *yrange;
	double *reverseYrange;
	double *reverseXrange;
	bool showReverse;
	bool hasReverse;
	int prevIndex;

	void preparePlot(QwtPlot *plot, InputDataset *dataset, QwtPlotCurve *curve, double *xrange);

public slots:
	void setSample(int sampleIndex);
private slots:
	void on_pushButton_toggled(bool checked);

signals:
	void indexChanged(int index);
};

#endif // DATASETVIEWER_H
