include(../common.pri)
BASEPATH = ../../..
PARASPIKES_LIBPATH = $${BASEPATH}/libs
CONFIG += qt \
    gui
LIBS += -L../debug \
    -L.
INCLUDEPATH += $${PARASPIKES_LIBPATH}/ann/include
LIBS += -L$${PARASPIKES_LIBPATH}/ann/lib \
    -lANN # Needed by libspc
INCLUDEPATH += $${PARASPIKES_LIBPATH}/qwt/src
LIBS += -L$${PARASPIKES_LIBPATH}/qwt/lib \
    -lqwt
LIBS += -L../designer \
    -lparaspikes-widgets-plugin
LIBS += -lgsl -lgslcblas

LIBS += -ltbb
# LIBS += -lprofiler -ltcmalloc # used for profiler and more efficient malloc

INCLUDEPATH += ../designer \
	$${PARASPIKES_LIBPATH}/stann/include \
	$${PARASPIKES_LIBPATH}/tbb/include
HEADERS = spikewidget.h \
	susceptibilityplotwidget.h \
	mainwindow.h \
	datasetviewer.h \
	susceptibilitythread.h \
	clusterquality.h \
	\
    data/spikedata.h \
	data/inputdataset.h \
	data/dataloader.h \
	data/dataexporter.h \
	\
    spc/clustercollection.h \
    spc/spc.h \
    spc/spcfactory.h \
	spc/xyplot.h \
	spc/xyseries.h \
	spc/xycollectionplot.h \
	spc/clusteringalgorithm.h \
	spc/kmeans.h \
	spc/randomgenerator.h \
	\
	reduction/reduction.h \
	reduction/waveletreductionhighest.h \
    reduction/noreduction.h \
    reduction/reductionservice.h \
    reduction/waveletreductionfirst.h \
    reduction/waveletreductionfirstperchannel.h \
    reduction/pcareduction.h \
	reduction/peaksofchannelsreduction.h \
	\
	filtering/sdfilter.h \
    reduction/energypcareduction.h \
    reduction/scalebyenergyreduction.h \
    macros.h \
    reduction/pcaperchannelreduction.h \
    reduction/waveletreductionks.h \
    reduction/waveletreductionkssupervised.h \
    common.h \ 
		reduction/peakalignment.h \
    reduction/convolutionreduction.h

SOURCES = main.cpp \
    spikewidget.cpp \
    susceptibilityplotwidget.cpp \
    mainwindow.cpp \
	datasetviewer.cpp \
	susceptibilitythread.cpp \
	clusterquality.cpp \
	\
	data/spikedata.cpp \
    data/inputdataset.cpp \
    data/dataloader.cpp \
	data/dataexporter.cpp \
	\
    spc/spc.cpp \
    spc/clustercollection.cpp \
    spc/spcfactory.cpp \
	spc/xyplot.cpp \
	spc/xycollectionplot.cpp \
	spc/clusteringalgorithm.cpp \
	spc/kmeans.cpp \
	spc/randomgenerator.cpp \
	spc/xyseries.cpp \
	\
	reduction/waveletreductionhighest.cpp \
    reduction/noreduction.cpp \
    reduction/reductionservice.cpp \
	reduction/waveletreductionfirst.cpp \
    reduction/waveletreductionfirstperchannel.cpp \
    reduction/pcareduction.cpp \
	reduction/peaksofchannelsreduction.cpp \
	\
	filtering/sdfilter.cpp \
    reduction/energypcareduction.cpp \
    reduction/scalebyenergyreduction.cpp \
    reduction/pcaperchannelreduction.cpp \
    reduction/waveletreductionks.cpp \
    reduction/waveletreductionkssupervised.cpp \ 
		reduction/peakalignment.cpp \
    reduction/convolutionreduction.cpp

QT += opengl
FORMS += mainwindow.ui \
	datasetviewer.ui
DESTDIR = ../debug
