#include "peakalignment.h"
#include <iostream>

PeakAlignment::PeakAlignment()
{
}

PeakAlignment::~PeakAlignment() {

}

InputDataset* PeakAlignment::reduce(const InputDataset *input) {
	InputDataset *outData = new InputDataset(input->nDimensions, input->nSamples, input->nChannels);


	int channelSize = input->nDimensions / input->nChannels;
	//int wantedPeakIndex = channelSize / 3;

	// Find normal peak point
	double avgIndex = 0;
	for(unsigned int spike=0; spike < input->nSamples; spike++) {
		// Find peak in channel 0
		double maxVal = input->data[spike][0];
		int maxIndex = 0;
		for(int i=1;i<input->nDimensions;i++) {
			if(input->data[spike][i] > maxVal) {
				maxVal = input->data[spike][i];
				maxIndex = i % channelSize;
			}
		}
		avgIndex += maxIndex;

	}
	avgIndex /= input->nSamples;
	int wantedPeakIndex = (int)avgIndex;
	std::cout << "Peak alignment to index: " << wantedPeakIndex << std::endl;

	for(unsigned int spike=0; spike < input->nSamples; spike++) {
		// Find peak in channel 0
		double maxVal = input->data[spike][0];
		int maxIndex = 0;
		for(int i=1;i<input->nDimensions;i++) {
			if(input->data[spike][i] > maxVal) {
				maxVal = input->data[spike][i];
				maxIndex = i % channelSize;
			}
		}

		int delta = wantedPeakIndex - maxIndex;

		for(unsigned int channel=0; channel < input->nChannels; channel++) {
			for(int sampleInChannel=0; sampleInChannel < channelSize; sampleInChannel++) {
				int outIndex = channel*channelSize + sampleInChannel;
				int inIndex = outIndex - delta;
				int inIndexInChannel = inIndex - channelSize*channel;
				double val;

				if(inIndexInChannel > 0 && inIndexInChannel < channelSize) {
					val = input->data[spike][inIndex];
				} else {
					val = 0;
				}

				outData->data[spike][outIndex] = val;
			}
		}

	}

	return outData;
}

InputDataset* PeakAlignment::reverse(const InputDataset *input) {
	return NULL;
}
