#include "peaksofchannelsreduction.h"
#include <algorithm>
#include <iostream>

PeaksOfChannelsReduction::PeaksOfChannelsReduction()
{
}

PeaksOfChannelsReduction::~PeaksOfChannelsReduction()
{
}

InputDataset *PeaksOfChannelsReduction::reduce(const InputDataset *input) {
	int channels = 4;
	int samplesPerChannel = 50;
	InputDataset *outData = new InputDataset(channels, input->nSamples, 1);
	outData->resizeVectorsToParameters();

	/*
	// Measure overflow count
	for(int sampleIndex=0;sampleIndex<input->nSamples;sampleIndex++) {
		int overflowCount = 0;
		for(int i=0;i<200;i++) {
			if(input->data[sampleIndex][i] == 128 || input->data[sampleIndex][i] == -128) {
				overflowCount++;
			}
		}
		if(overflowCount > 0)
			std::cerr << sampleIndex << ";" << overflowCount << "\n";
	}
	*/

	for(unsigned int sampleIndex=0;sampleIndex<input->nSamples;sampleIndex++) {
		for(int channel=0;channel<channels;channel++) {
			double maxForChannel = *std::max_element(input->data[sampleIndex].begin()+channel*samplesPerChannel, input->data[sampleIndex].begin()+channel*samplesPerChannel + samplesPerChannel);
			outData->data[sampleIndex][channel] = maxForChannel;
		}
	}

	outData->nChannels = channels;
	return outData;

}

InputDataset *PeaksOfChannelsReduction::reverse(const InputDataset *input) {
	return NULL;
}
