#include "reductionservice.h"

QStringList ReductionService::availableReductions() {
	QStringList types;
	types << "No reduction" << "Wavelet transform (first)" << "Wavelet transform (first per channel)"
			<< "Wavelet (KS)" << "Wavelet (KS supervised)" << "Wavelet transform (highest)" << "PCA" << "PCA per channel"
			<< "Peaks of channels" << "Energy PCA" << "Scale by energy (no reduction)"
			<< "Peak alignment" << "Convolution reduction";
	return types;
}

Reduction *ReductionService::getReductionIndex(int index) {
	switch(index) {
	case 0:
		return new NoReduction();
	case 1:
		return new WaveletReductionFirst();
	case 2:
		return new WaveletReductionFirstPerChannel();
	case 3:
		return new WaveletReductionKS();
	case 4:
		return new WaveletReductionKsSupervised();
	case 5:
		return new WaveletReductionHighest();
	case 6:
		return new PcaReduction();
	case 7:
		return new PcaPerChannelReduction();
	case 8:
		return new PeaksOfChannelsReduction();
	case 9:
		return new EnergyPcaReduction();
	case 10:
		return new ScaleByEnergyReduction();
	case 11:
		return new PeakAlignment();
	case 12:
		return new ConvolutionReduction();
	}
	return NULL;
}
