#include "scalebyenergyreduction.h"
#include <math.h>
#include <iostream>
#include "macros.h"

static double energyForSpike(const std::vector<double> *spike) {
	double squareSum = 0;
	for(std::vector<double>::const_iterator it = spike->begin(); it != spike->end(); it++) {
		squareSum += (*it) * (*it);
	}

	double res = sqrt(squareSum) / spike->size();
	if(res == 0.0)
		return 1.0 / spike->size();
	return res;
}

ScaleByEnergyReduction::ScaleByEnergyReduction()
{
}

InputDataset* ScaleByEnergyReduction::reduce(const InputDataset *input) {
	InputDataset *scaledInput = new InputDataset(*input);

	for(unsigned int spike=0; spike < scaledInput->nSamples; spike++) {
		double energy = energyForSpike(&(scaledInput->data[spike]));
		for(unsigned int dim=0; dim < scaledInput->nDimensions; dim++) {
			scaledInput->data[spike][dim] /= energy;
		}
	}
	return scaledInput;
}

InputDataset* ScaleByEnergyReduction::reverse(const InputDataset *input) {
	return NULL;
}
