#ifndef CLUSTERCOLLECTION_H_
#define CLUSTERCOLLECTION_H_
#include <vector>
#include <map>

class ClusterCollection {
public:
	ClusterCollection(int nPoints);
	virtual ~ClusterCollection();

	void reset();
	bool isAssignedToCluster(int index);
	int getContainingCluster(int index);
	int getAssignedClustersCount();
	void assign(int clusterIndex, int pointIndex);
	int startCluster();
	void markMergeClustersForPointIndexes(int a, int b);
	void doMerge();

	void removeEmptyClusters();

	void printClusters();

	//accessed cluster, point
	std::vector<std::vector<int> > clusters;
private:
	std::vector<std::vector<int> > mergeClusterLists;
	std::map<int, int> mergeTargets;
	void markMergeClusters(int clusterIndexA, int clusterIndexB);
	int *clusterMemberships;

	unsigned int nPoints;

	int assignedClusters;
};

#endif /* CLUSTERCOLLECTION_H_ */
