#include "randomgenerator.h"

RandomGenerator::RandomGenerator(double min, double max, unsigned int seed)
{
	init(min, max, seed);
}

RandomGenerator::RandomGenerator(RandomGenerator *oldRand) {
	init(oldRand->min, oldRand->max, oldRand->rng());
}

void RandomGenerator::init(int min, int max, unsigned int seed) {
	this->min = min;
	this->max = max;

	rng.seed(seed);

	randRangeDist = new boost::uniform_smallint<int>(min, max);
	randRange = new boost::variate_generator<GENERATOR&, boost::uniform_smallint<int> >(rng, *randRangeDist);
}

RandomGenerator::~RandomGenerator() {
	delete randRangeDist;
}


int RandomGenerator::randInRange() {
	return (*randRange)();
}

double RandomGenerator::randFrac() {
	return rand01dist(rng);
}

