#ifndef RANDOMGENERATOR_H
#define RANDOMGENERATOR_H

#define MT_GEN
// #define LC_GEN

#ifdef MT_GEN
#include <boost/random/mersenne_twister.hpp>
#define GENERATOR boost::mt19937
#endif

#ifdef LC_GEN
#include <boost/random/linear_congruential.hpp>
#define GENERATOR boost::rand48
#endif

#include <boost/random/variate_generator.hpp>
#include <boost/random/uniform_smallint.hpp>
#include <boost/random/uniform_01.hpp>

class RandomGenerator
{
public:
	RandomGenerator(double min, double max, unsigned int seed=0);
	RandomGenerator(RandomGenerator *oldRand);
	~RandomGenerator();

	double randFrac();
	int randInRange();

	int min, max;

	GENERATOR rng; // The generator

private:
	void init(int min, int max, unsigned int seed);
	boost::uniform_01<> rand01dist;
	boost::uniform_smallint<int> *randRangeDist;
	boost::variate_generator<GENERATOR&, boost::uniform_smallint<> >  *randRange;
};

#endif // RANDOMGENERATOR_H
