#include "spcfactory.h"
#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <boost/algorithm/string.hpp>
#include <vector>
#include "spc.h"

Spc *SpcFactory::createIris() {
        std::ifstream irisFile;
        irisFile.open("input/iris.data", std::ios::in);
        std::string line;

        getline(irisFile, line);
        int nSamples = strtol(line.c_str(), NULL, 10);
        getline(irisFile, line);
        int nDimensions = strtol(line.c_str(), NULL, 10);
	std::vector<std::vector<double> > *points = new std::vector<std::vector<double> >();
        points->reserve(nSamples);




        for(int i=0;i<nSamples;i++) {
		getline(irisFile, line);
		std::vector<std::string> strs;
		boost::split(strs, line, boost::is_any_of(","));

		std::vector<double> foo = *new std::vector<double>(nDimensions);
		for (unsigned int j = 0; j < strs.size() - 1; j++) {
			foo[j] = std::strtof(strs[j].c_str(), NULL);
		}

		points->push_back(foo);
	}
	irisFile.close();
	return new Spc(*points);
}

Spc *SpcFactory::createRandom() {

	int nDimensions = 15, nPoints = 1000;
	std::vector<std::vector<double> > *points = new std::vector<std::vector<double> >();
	points->reserve(nPoints);
	for (int i = 0; i < nPoints; i++) {
		std::vector<double> foo = *new std::vector<double>(nDimensions);
		for (int j = 0; j < nDimensions; j++) {
			foo[j] = (double) (rand() % 100000) / 1000.0f;
		}

		points->push_back(foo);
	}
	return new Spc(*points);

}

Spc *SpcFactory::createSpaeth() {

	int nDimensions = 2;
	std::vector<std::vector<double> > *points = new std::vector<std::vector<double> >();

	std::ifstream dataset;
	dataset.open("input/spaeth5.data", std::ios::in);

	std::string line;
	while (dataset.good()) {
		getline(dataset, line);
		std::vector<std::string> strs;
		boost::split(strs, line, boost::is_any_of(","));

		std::vector<double> foo = *new std::vector<double>(nDimensions);
		for (unsigned int j = 0; j < strs.size(); j++) {
			foo[j] = std::strtof(strs[j].c_str(), NULL);
		}

		points->push_back(foo);
	}
	dataset.close();
	return new Spc(*points);

}
