#include <iostream>
#include <fstream>
#include "spc/xyplot.h"

#include <algorithm>

bool pointxcompare(QPointF a, QPointF b) {
	return a.x() < b.x();
}

XyPlot::XyPlot() {
}

void XyPlot::insert(double x, double y) {
	tbb::concurrent_hash_map<double, double>::accessor a;
	values.insert(a, x);
	a->second = y;
}

XyPlot::~XyPlot() {
}



XYSeries* XyPlot::to_X_XY_Series() {
	QVector<QPointF> pointsAsVector;

	pointsAsVector.resize(values.size());
	tbb::concurrent_hash_map<double, double>::iterator it;
	int i= -1;
	for(it = values.begin();it != values.end(); it ++) {
		i++;
		double x = (*it).first;
		double xy = (*it).second * x;
		pointsAsVector[i].setX(x);
		pointsAsVector[i].setY(xy);
	}
	std::sort(pointsAsVector.begin(), pointsAsVector.end(), pointxcompare);

	return new XYSeries(pointsAsVector);
}

XYSeries* XyPlot::to_X_Y_Series() {
	QVector<QPointF> pointsAsVector;

	pointsAsVector.resize(values.size());
	tbb::concurrent_hash_map<double, double>::iterator it;
	int i= -1;
	for(it = values.begin();it != values.end(); it ++) {
		i++;
		double x = (*it).first;
		double y = (*it).second;
		pointsAsVector[i].setX(x);
		pointsAsVector[i].setY(y);
	}
	std::sort(pointsAsVector.begin(), pointsAsVector.end(), pointxcompare);

	return new XYSeries(pointsAsVector);
}

XYSeries *XyPlot::to_X_Y_LogSeries() {
	QVector<QPointF> pointsAsVector;

	pointsAsVector.resize(values.size());
	tbb::concurrent_hash_map<double, double>::iterator it;
	int i= -1;
	for(it = values.begin();it != values.end(); it ++) {
		i++;
		double x = (*it).first;
		double y = 0.0;
		if((*it).second)
			y = log10((*it).second);
		pointsAsVector[i].setX(x);
		pointsAsVector[i].setY(y);
	}
	std::sort(pointsAsVector.begin(), pointsAsVector.end(), pointxcompare);

	return new XYSeries(pointsAsVector);
}



XYSeries* XyPlot::to_X_Y_05series() {
	QVector<QPointF> pointsAsVector;

	pointsAsVector.resize(values.size());
	tbb::concurrent_hash_map<double, double>::iterator it;
	int i= -1;
	for(it = values.begin();it != values.end(); it ++) {
		i++;
		double x = (*it).first;
		double y = fmax(0.5,(*it).second);
		pointsAsVector[i].setX(x);
		pointsAsVector[i].setY(y);
	}
	std::sort(pointsAsVector.begin(), pointsAsVector.end(), pointxcompare);

	return new XYSeries(pointsAsVector);
}
