#include <QtGui>
#include <QtOpenGL>

#include "spikewidget.h"

SpikeWidget::SpikeWidget(QWidget *parent) :
	QGLWidget(QGLFormat(QGL::SampleBuffers), parent)
{
    // TODO receive real data

    SpikeData mySpike;
    mySpike.numChannels = 4;
    mySpike.numSamplesPerChannel=50;
    double *data = new double[200];
    mySpike.data = data;

    spikes.push_back(mySpike);

}

QSize SpikeWidget::minimumSizeHint() const
{
    return QSize(50, 50);
}

QSize SpikeWidget::sizeHint() const {
    return QSize(50, 50);
}

void SpikeWidget::resizeGL(int w, int h) {
    glViewport(0, 0, w, h);
}

void SpikeWidget::initializeGL() {
    glDisable(GL_DEPTH_TEST);
    glEnable (GL_LINE_SMOOTH);

}

void SpikeWidget::paintGL() {
    glClear(GL_COLOR_BUFFER_BIT);
    glColor3f(1.0,.5,.5);
    glLineWidth(1.0);

    glPushMatrix();


    for(unsigned int s=0;s<spikes.size();s++) {
        SpikeData spike = spikes[s];
        int samples = spike.numChannels * spike.numSamplesPerChannel;

        glBegin(GL_LINE_STRIP);
        for(int i=0;i<samples;i++) {
            glVertex2d(-1.0 + (2.0/samples) * i , spike.data[i]);
        }
        glEnd();
    }


    glPopMatrix();
}
