#ifndef SUSCEPTIBILITYPLOTWIDGET_H
#define SUSCEPTIBILITYPLOTWIDGET_H

#include "qwt_plot.h"
#include "spc/xyplot.h"
#include "qwt_plot_curve.h"
#include "qwt_plot_marker.h"
 #include <QEvent>

class SusceptibilityPlotWidget : public QwtPlot
{
    Q_OBJECT


public:
    SusceptibilityPlotWidget(QWidget *parent = 0);
	void setSuPlot(XyPlot &plot);


private:
    QwtPlotCurve curve;
    QwtPlotMarker selectedTemperatureMarker;
    QwtPlotMarker followingTemperatureMarker;

	double currentTemperature;

signals:
    void temperatureChanged(double newTemperature);

public slots:
	void setTemperature(double temperature);
    void handleClick(const QPointF &point);
};

#endif // SUSCEPTIBILITYPLOTWIDGET_H
